procedure SillySort(var A: arraytype; i, j: integer);
  (* sorts subarray A[i..j] *)
  var temp: integer;
  begin
    if i < j  (* If i = j there is nothing to do. *)
      then begin
             m := (i+j) div 2;
             SillySort(A,i,m);
             SillySort(A,m+1,j);
             (* Largest element in the entire array is the larger
                of A[m] and A[j]. *)
             if A[m] > A[j]
               then begin (* swap *)
                      temp := A[m]; A[m] := A[j]; A[j] := temp
                    end;
             (* Largest element in place--sort the rest. *)
             SillySort(A,i,j-1)
           end
  end; (* SillySort *)
